//	Name:			binary_search.cpp
//	Autor			Hong Phuc Bui
//	(redaktionelle nderungen + Funktion visualize(): Damian Weber)
//	Datum			15.12.2007
//	Copyleft		GNU
//	Beschreibung	        Binre Suche
//                              (Vorlesung Informatik 1 vom 13.12.2007)
//	Version			1.0
//
// compilieren mit
// c++ -O2 -o binary_search binary_search.cpp
// oder
// make
// (siehe Makefile)


#include <iostream>

using namespace std;

void visualize(int y[],int n,int x,int l,int r, int m)
{
	int j;

	cout << "|";
	for (j=0;j<n;j++)
	{
		if (j<l || j>r)
		{
			cout << "-";
			continue;
		}
		if (y[j]==x)
		{
			cout << "*";
			continue;
		}
		if (j==m)
		{
			cout << "M";
			continue;
		}
		if (j==l && j==r)
		{
			cout << "!";
			continue;
		}
		if (j==l)
		{
			cout << "[";
			continue;
		}
		if (j==r)
		{
			cout << "]";
			continue;
		}
		cout << "#";
	}
	cout << "|" << endl;
}

/*
	Eingabe: n   Anzahl der Elemente in Array y[]
	         y[] sortiertes Array
		 x   zu suchendes Element
        Ausgabe: Arrayindex m mit x==y[m]
*/
int binary_s(int n, int y[], int x)
{
	//Deklarationen und Initalisierung
	int l = 0;			// linke Grenze
	int r = n-1;			// rechte Grenze
	int m = (l+r)/2;	        // mittleres Element

	// Schleife: solange nicht gefunden und Grenzen ok
	while (x != y[m] && l < r)
	{
		visualize(y,n,x,l,r,m);
		sleep(4);
		if ( x < y[m] ) // Objekt links von der Mitte ?
		{
			r = m -1; // ja -> rechte Grenze verndern
		}
		else
		{
			l = m +1; // nein -> linke Grenze verndern
		}

		m=(l + r)/2;
	}
	visualize(y,n,x,l,r,m);
	// gefunden?
	if ( x == y[m])
	{
		return m; // ja
	}
	else
	{
		return -1; // nein
	}
}

int main()
{
	const int MAX = 96;
	int x=1000000000 ;
	// Array um binary_s() zu testen.
	int a[MAX];
	int j;

	srand48(time(NULL));

	a[0]=1; a[1]=1;  // Fibonacci-Startwerte
	j=1; // fr Fibonacci setze j=2
	while ( (a[j-1]<=x)&&(j < MAX) )
	{
		// a[j] = a[j-1] + a[j-2]; // Fibonacci Iteration
		a[j] = a[j-1] + lrand48()%10+1; // nicht so stark wachsend wie Fib
		j++;
	}
	j--;

	//Fibonacci-Folge ausgeben
	cout <<endl;
	for (int i=0; i<j; i++)
	{
		cout << a[i] << " ";
	}
	cout << endl;

	int ck_zahle;
	cout << "zu prfende Zahl eingeben " ;
	cin >> ck_zahle;
	int platz = binary_s(j, a, ck_zahle);
	cout << "Position :"<< platz << endl;
	return 0;
}

